; You should include this somewhere at the end of your asm file.
;--------------------------------------------------------------------------------
MULT_8X8:
;-------------------			; Initialize
	PUSH	DE			; Save reg.DE
	XOR	A			; Reg.A <- 0; flag.C <- 0
	CP	H			; Compare H with A
	JP	Z, ERROR		; If zero, jump
	CP	L			; Compare L with A
	JR	Z, ERROR		; If zero, jump
	LD	D,A			; Clear high byte of multiplier
	LD	E,H			; Load low byte of multiplier
	LD	A,L			; Load 8-bit multiplicand in reg.A
	SBC	HL,HL			; Clear reg.HL (flag.C was 0 from XOR A)
					;	Initializes the result to $0000
;-------------------			; Start the multiplication
	JR	TEST_MULTIPLICAND	; Start at the test
ERROR:
	SUB	HL, HL			; Clear HL
	JR	MULT_8X8_END		; Then goto the end of the program
MULT_LOOP:
	ADD	HL,DE
NEXT_BIT:
	SLA	E			; Multiply the multiplier by 2 - shift 0 into LSB
	RLCA	D			; finish the 2-byte shift
TEST_MULTIPLICAND
	SRL	A			; Update the multiplicand
	JR	C,MULT_LOOP		; C - do the addition
	JR	NZ,NEXT_BIT		; NZ - continue the multiplication
					; Z - multiplication is done

MULT_8X8_END;
;-------------------			; Cleanup before exit
	POP	DE			; Restore reg.DE
					; Reg.A is $00
					; Reg.HL contains 16-bit result of multiply
	RET
;----------------------------------------------------------------------------------
